/*---------------------------------------------------------------------------*
  Project:  iWnn
  File:     ex_giji.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
  
 $Revision: $
 *---------------------------------------------------------------------------*/
#ifndef _EX_GIJI_H_
#define _EX_GIJI_H_
#include <nn/middleware.h>

#ifdef __cplusplus 
extern "C" {
#endif

#include "nj_lib.h"
#include "nj_dicif.h"

/************************************************/
/*           Include files                  */
/************************************************/
/************************************************/
/* Pseudo-candidate information definition                               */
/************************************************/
/* Please see man pages for details 
 
 
 
 */
#define NJ_GIJISET_MAX          37

/* Please see man pages for details 
 
 */
typedef struct {
    s16  count;                /* Number of registrations stored in type[] */
    NN_PADDING2;
    u8  type[NJ_GIJISET_MAX]; /* Pseudo-candidate type */
    NN_PADDING3;
} NJ_GIJISET;

/* Please see man pages for details 
 
 
 
 
 */
/*    Pseudo-candidate type definition    */
#define NJ_TYPE_HAN_EIJI_CAP             5 /* Please see man pages for details */
#define NJ_TYPE_ZEN_EIJI_CAP             6 /* Please see man pages for details */
#define NJ_TYPE_HAN_EIJI_UPPER           7 /* Please see man pages for details */
#define NJ_TYPE_ZEN_EIJI_UPPER           8 /* Please see man pages for details */
#define NJ_TYPE_HAN_EIJI_LOWER           9 /* Please see man pages for details */
#define NJ_TYPE_ZEN_EIJI_LOWER          10 /* Please see man pages for details */
#define NJ_TYPE_HAN_SUUJI_COMMA         13 /* Please see man pages for details */
#define NJ_TYPE_HAN_TIME_HH             14 /* Please see man pages for details */
#define NJ_TYPE_HAN_TIME_MM             15 /* Please see man pages for details */
#define NJ_TYPE_HAN_TIME_HM             16 /* Please see man pages for details */
#define NJ_TYPE_HAN_TIME_HMM            17 /* Please see man pages for details */
#define NJ_TYPE_HAN_TIME_HHM            18 /* Please see man pages for details */
#define NJ_TYPE_HAN_TIME_HHMM           19 /* Please see man pages for details */
#define NJ_TYPE_HAN_TIME_HMM_SYM        20 /* Please see man pages for details */
#define NJ_TYPE_HAN_TIME_HHMM_SYM       21 /* Please see man pages for details */
#define NJ_TYPE_HAN_DATE_YYYY           22 /* Please see man pages for details */
#define NJ_TYPE_HAN_DATE_MM             23 /* Please see man pages for details */
#define NJ_TYPE_HAN_DATE_DD             24 /* Please see man pages for details */
#define NJ_TYPE_HAN_DATE_MD             25 /* Please see man pages for details */
#define NJ_TYPE_HAN_DATE_MDD            26 /* Please see man pages for details */
#define NJ_TYPE_HAN_DATE_MMD            27 /* Please see man pages for details */
#define NJ_TYPE_HAN_DATE_MMDD           28 /* Please see man pages for details */
#define NJ_TYPE_HAN_DATE_MD_SYM         29 /* Please see man pages for details */
#define NJ_TYPE_HAN_DATE_MDD_SYM        30 /* Please see man pages for details */
#define NJ_TYPE_HAN_DATE_MMD_SYM        31 /* Please see man pages for details */
#define NJ_TYPE_HAN_DATE_MMDD_SYM       32 /* Please see man pages for details */
#define NJ_TYPE_HAN_SUUJI_YOMI          33 /* Please see man pages for details */
#define NJ_TYPE_ZEN_SUUJI_YOMI          34 /* Please see man pages for details */
#define NJ_TYPE_ZEN_KANSUUJI_YOMI       35 /* Please see man pages for details */
#define NJ_TYPE_ZEN_KANSUUJI_KURAI_YOMI 36 /* Please see man pages for details */

/* Please see man pages for details 
 
 
 
 
 
 
 */
#define NJ_TYPE_LIMIT_VALUE  (NJ_TYPE_ZEN_KANSUUJI_KURAI_YOMI)
/*
 * Definition scope for pseudo-candidate types for application extension
 *
 * Call a function customized for the application if the pseudo-candidate type is outside this scope.

 */
/* Please see man pages for details */
#define NJ_GIJI_TYPE_CUST_MIN    170
/* Please see man pages for details */
#define NJ_GIJI_TYPE_CUST_MAX    255




/***********************************************************************
 * Dictionary interface extern declarations
 ***********************************************************************/
NJ_EXTERN s16 njex_giji_dic(NJ_CLASS* iwnn, u16 request, NJ_PROGRAM_DIC_MESSAGE* message);
NJ_EXTERN s16 njex_get_giji(NJ_CLASS *iwnn, wchar_t *yomi, u8 type, NJ_RESULT *result);



#ifdef __cplusplus 
}
#endif

#endif /*_EX_GIJI_H_*/
