/*---------------------------------------------------------------------------*
  Project:  iWnn
  File:     nj_dicif.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
  
 $Revision: $
 *---------------------------------------------------------------------------*/
 
#ifndef _NJ_DICIF_H_
#define _NJ_DICIF_H_
#include <nn/middleware.h>

#ifdef __cplusplus 
extern "C" {
#endif
 

#define NJG_OP_SEARCH           0x0001 /* Please see man pages for details */
#define NJG_OP_SEARCH_NEXT      0x0002 /* Please see man pages for details */
#define NJG_OP_GET_WORD_INFO    0x0003 /* Please see man pages for details */
#define NJG_OP_GET_STROKE       0x0004 /* Please see man pages for details */
#define NJG_OP_GET_STRING       0x0005 /* Please see man pages for details */
#define NJG_OP_GET_ADDITIONAL   0x000A /* Please see man pages for details */
#define NJG_OP_LEARN            0x0006 /* Please see man pages for details */
#define NJG_OP_UNDO_LEARN       0x0007 /* Please see man pages for details */
#define NJG_OP_ADD_WORD         0x0008 /* Please see man pages for details */
#define NJG_OP_DEL_WORD         0x0009 /* Please see man pages for details */

/* Please see man pages for details 
 
 */
typedef struct {
    u16                   f_hinsi;        /* Please see man pages for details */
    u16                   b_hinsi;        /* Please see man pages for details */
    u16                   connect;        /* Please see man pages for details */
    u16                   undo;           /* Please see man pages for details */
} NJG_LEARN_WORD;

/* Please see man pages for details 
 
 */
typedef struct {
    NJ_SEARCH_CONDITION *       condition;      /* Please see man pages for details */
    NJ_SEARCH_LOCATION_SET *    location;       /* Please see man pages for details */
    NJ_DIC_SET *                dicset;         /* Please see man pages for details */
    NJ_WORD *                   word;           /* Please see man pages for details */
    NJG_LEARN_WORD *            lword;          /* Please see man pages for details */
    wchar_t *                   stroke;         /* Please see man pages for details */
    wchar_t *                   string;         /* Please see man pages for details */
    wchar_t *                   additional;     /* Please see man pages for details */
    u16                   stroke_size;    /* Please see man pages for details */
    u16                   string_size;    /* Please see man pages for details */
    u32                   additional_size;/* Please see man pages for details */
    u16                   dic_idx;        /* Please see man pages for details */
    NN_PADDING2;
} NJ_PROGRAM_DIC_MESSAGE;

/* Please see man pages for details 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 */
typedef s16(*NJ_PROGRAM_DIC_IF)(NJ_CLASS *iwnn, u16 request, NJ_PROGRAM_DIC_MESSAGE *message);





#ifdef __cplusplus 
}
#endif
#endif /* _NJ_DICIF_H_ */
