/*---------------------------------------------------------------------------*
  Project:  iWnn
  File:     nj_ext.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
  
 $Revision: $
 *---------------------------------------------------------------------------*/
 
#ifndef _NJ_EXTERN_H_
#define _NJ_EXTERN_H_

#ifdef __cplusplus 
extern "C" {
#endif 
 

/************************************************/
/*          Common internal iWnn definitions                  */
/************************************************/

/*
 * File pointer position definition
 * NOTE: Change to match the system.
 */
#ifndef _IWNN_CTR_MODE
#define NJ_FILE_IO_SEEK_CUR             SEEK_CUR      /* Please see man pages for details */
#define NJ_FILE_IO_SEEK_END             SEEK_END      /* Please see man pages for details */
#define NJ_FILE_IO_SEEK_SET             SEEK_SET      /* Please see man pages for details */
#else /* !_IWNN_CTR_MODE */
#define NJ_FILE_IO_SEEK_CUR             nn::fs::POSITION_BASE_CURRENT    /* Please see man pages for details */
#define NJ_FILE_IO_SEEK_END             nn::fs::POSITION_BASE_END        /* Please see man pages for details */
#define NJ_FILE_IO_SEEK_SET             nn::fs::POSITION_BASE_BEGIN      /* Please see man pages for details */
#endif /* !_IWNN_CTR_MODE */



/*
 * Macro for taking up character code-dependent processing
 */
/* Please see man pages for details 
 
 
 
 */
#define NJ_MAX_CHAR_LEN  2

/* Please see man pages for details 
 
 
 
 
 
 
 
 */
#ifdef NJ_OPT_UTF16
#define NJ_CHAR_IS_EQUAL(a, b) \
    ( (((u8*)(a))[0] == ((u8*)(b))[0]) && (((u8*)(a))[1] == ((u8*)(b))[1]) )
#else /* NJ_OPT_UTF16 */
#define NJ_CHAR_IS_EQUAL(a, b) \
    ( (((u8*)(a))[0] == ((u8*)(b))[0]) )
#endif /* NJ_OPT_UTF16 */

/* Please see man pages for details 
 
 
 
 
 
 
 
 */
#ifdef NJ_OPT_UTF16
#define NJ_CHAR_IS_LESSEQ(a, b)                                         \
    ( (((u8*)(a))[0] < ((u8*)(b))[0]) ||                    \
      ((((u8*)(a))[0] == ((u8*)(b))[0]) && (((u8*)(a))[1] <= ((u8*)(b))[1])) )
#else /* NJ_OPT_UTF16 */
#define NJ_CHAR_IS_LESSEQ(a, b) \
    ( (((u8*)(a))[0] <= ((u8*)(b))[0]) )
#endif /* NJ_OPT_UTF16 */

/* Please see man pages for details 
 
 
 
 
 
 
 
 */
#ifdef NJ_OPT_UTF16
#define NJ_CHAR_IS_MOREEQ(a, b)                                         \
    (  (((u8*)(a))[0] >  ((u8*)(b))[0]) ||                  \
      ((((u8*)(a))[0] == ((u8*)(b))[0]) && (((u8*)(a))[1] >= ((u8*)(b))[1])) )
#else /* NJ_OPT_UTF16 */
#define NJ_CHAR_IS_MOREEQ(a, b) \
    ( ((u8*)(a))[0] >= ((u8*)(b))[0] )
#endif /* NJ_OPT_UTF16 */

/* Please see man pages for details 
 
 
 
 
 
 
 
 
 */
#ifdef NJ_OPT_UTF16
#define NJ_CHAR_DIFF(a, b)                                              \
    ((s16)                                                         \
     ( (((u8*)(a))[0] == ((u8*)(b))[0])                     \
       ? (((u8*)(a))[1] - ((u8*)(b))[1])                    \
       : (((u8*)(a))[0] - ((u8*)(b))[0]) )                  \
     )
#else /* NJ_OPT_UTF16 */
#define NJ_CHAR_DIFF(a, b)   ((s16)(*(a) - *(b)))
#endif /* NJ_OPT_UTF16 */

/* Please see man pages for details 
 
 
 
 
 */
#ifdef NJ_OPT_UTF16
#define NJ_CHAR_COPY(dst, src)                                          \
    {                                                                   \
        ((u8*)(dst))[0] = ((u8*)(src))[0];                  \
        ((u8*)(dst))[1] = ((u8*)(src))[1];                  \
    }
#else /* NJ_OPT_UTF16 */
#define NJ_CHAR_COPY(dst, src)                          \
    { ((u8*)(dst))[0] = ((u8*)(src))[0]; }
#endif /* NJ_OPT_UTF16 */

/* Please see man pages for details 
 
 
 
 
 
 
 */
#ifdef NJ_OPT_UTF16
#define NJ_CHAR_IS_HANKANA_DAKUTEN(c)  NJ_CHAR_IS_EQUAL((c), "\xff\x9e")
#else /* NJ_OPT_UTF16 */
#define NJ_CHAR_IS_HANKANA_DAKUTEN(c)  (*(c) == 0xde)
#endif /* NJ_OPT_UTF16 */

/* Please see man pages for details 
 
 
 
 
 
 
 */
#ifdef NJ_OPT_UTF16
#define NJ_CHAR_IS_ENABLE_HANKANA_DAKUTEN(c)                            \
    ( (NJ_CHAR_IS_MOREEQ((c), "\xff\x76") && NJ_CHAR_IS_LESSEQ((c), "\xff\x84")) || \
      (NJ_CHAR_IS_MOREEQ((c), "\xff\x8a") && NJ_CHAR_IS_LESSEQ((c), "\xff\x8e")) )
#else /* NJ_OPT_UTF16 */
#define NJ_CHAR_IS_ENABLE_HANKANA_DAKUTEN(c)    \
    ( ((*(c) >= 0xb6) && (*(c) <= 0xc4)) ||     \
      ((*(c) >= 0xca) && (*(c) <= 0xce)) )
#endif /* NJ_OPT_UTF16 */

/* Please see man pages for details 
 
 
 
 
 
 
 */
#ifdef NJ_OPT_UTF16
#define NJ_CHAR_IS_HANKANA_HANDAKUTEN(c)  NJ_CHAR_IS_EQUAL((c), "\xff\x9f")
#else /* NJ_OPT_UTF16 */
#define NJ_CHAR_IS_HANKANA_HANDAKUTEN(c)  (*(c) == 0xdf)
#endif /* NJ_OPT_UTF16 */

/* Please see man pages for details 
 
 
 
 
 
 
 */
#ifdef NJ_OPT_UTF16
#define NJ_CHAR_IS_ENABLE_HANKANA_HANDAKUTEN(c)                         \
    (NJ_CHAR_IS_MOREEQ((c), "\xff\x8a") && NJ_CHAR_IS_LESSEQ((c), "\xff\x8e"))
#else /* NJ_OPT_UTF16 */
#define NJ_CHAR_IS_ENABLE_HANKANA_HANDAKUTEN(c)   ((*(c) >= 0xca) && (*(c) <= 0xce))
#endif /* NJ_OPT_UTF16 */

/* Please see man pages for details 
 
 
 
 
 
 
 */
#define NJ_CHAR_STRLEN_IS_0(c)   (*(c) == NJ_CHAR_NUL)

/* Please see man pages for details 
 
 
 
 
 
 
 
 
 
 */
#ifdef NJ_OPT_UTF16
#define NJ_CHAR_ILLEGAL_DIC_YINDEX(size)   ((size) != 2)
#else  /* NJ_OPT_UTF16 */
#define NJ_CHAR_ILLEGAL_DIC_YINDEX(size)   ((size) > 2)
#endif /* NJ_OPT_UTF16 */


#ifdef NJ_OPT_UTF16
#define NJ_CHAR_LEN(s)                                                  \
    ( (NJ_CHAR_IS_MOREEQ((s), "\xD8\x00") && NJ_CHAR_IS_LESSEQ((s), "\xDB\xFF")) \
      ? ( (*((s)+1) == NJ_CHAR_NUL) ? 1 : 2)                            \
      : 1) /* Surrogate pairs */
#else /* NJ_OPT_UTF16 */
#define NJ_CHAR_LEN(s)                                                     \
    ( (((*(s) >= 0x81) && (*(s) < 0xa0)) || ((*(s) > 0xdf) && (*(s) <= 0xfc))) \
      ? ((*((s) + 1) == NJ_CHAR_NUL) ? 1 : 2)                           \
      : 1 )
#endif /* NJ_OPT_UTF16 */

#ifdef NJ_OPT_UTF16
#define UTL_CHAR(s)  1
#else /* NJ_OPT_UTF16 */
#define UTL_CHAR(s)  NJ_CHAR_LEN(s)
#endif /* NJ_OPT_UTF16 */


#define NJ_GET_DIC_INFO(dicinfo) ((u8)((dicinfo)->type))

#define NJ_GET_DIC_TYPE_EX(type, handle) \
            (  ((type) == NJ_DIC_H_TYPE_PROGRAM)     ? NJ_DIC_TYPE_PROGRAM :                    /* Pseudo-dictionary */ \
              (((type) == NJ_DIC_H_TYPE_PROGRAM_FZK) ? NJ_DIC_TYPE_PROGRAM_FZK :                /* Pseudo-dictionary - ancillary words - */ \
               (((type) == NJ_DIC_H_TYPE_ON_FLASH) ? ((NJ_FLASH_DIC_INFO*)(handle))->dictype :  /* FLASH dictionary */ \
                                NJ_GET_DIC_TYPE((handle)))) )                                   /* Normal dictionary */

#define NJ_CLEAR_OTHERFREQ_IN_DICINFO(info) \
    { \
        (info)->dic_freq[NJ_MODE_TYPE_YOSOKU].base  = 0; \
        (info)->dic_freq[NJ_MODE_TYPE_YOSOKU].high  = 0; \
        (info)->dic_freq[NJ_MODE_TYPE_MORPHO].base  = 0; \
        (info)->dic_freq[NJ_MODE_TYPE_MORPHO].high = 0; \
    }


#define GET_FLASH_CACHE_HEAD(h) ((u8*)(((NJ_FLASH_DIC_INFO*)(h))->cache_area[NJ_FLASH_DIC_HEAD]))


/*-----------------------------------------------------*/
/* Dictionary adapter macro                                */
/*-----------------------------------------------------*/


#define GET_BITFIELD_16(data, pos, width)                        \
    ((u16)(((u16)(data) >> (16 - (pos) - (width))) & \
                 ((u16)0xffff >> (16 - (width)       ))))

#define GET_BITFIELD_32(data, pos, width)       \
    ((u32)(((u32)(data) >> (32 - (pos) - (width))) & ((u32)0xffffffff >> (32 - (width)))))

#define GET_BIT_TO_BYTE(bit) ((u8)(((bit) + 7) >> 3))

#define V_ZOKUSEI_ADDR(h,x,y) (((h) + (u32)(((x) - 1) * (y))))

#define R_ZOKUSEI_ADDR(h,x,y) (((h) + (u32)(((x) - 1) * (y))))


#define INIT_KEYWORD_IN_NJ_DIC_SET(x) \
    { (x)->keyword[0] = NJ_CHAR_NUL; (x)->keyword[1] = NJ_CHAR_NUL; }

#define GET_ERR_FUNCVAL(errval) \
    ((u16)(((u16)(errval) & 0x007F) << 8))


#define RLT_GETYOMILEN(x) \
    ((u16)(NJ_GET_YLEN_FROM_STEM(&((x)->word)) + NJ_GET_YLEN_FROM_FZK(&((x)->word))))

#define RLT_HASFZK(x) ((u8)((NJ_GET_YLEN_FROM_FZK(&((x)->word))==0)?0:1))

#define RLT_GETLASTPOS(x) \
    ((u16)(RLT_HASFZK(x)?NJ_GET_BPOS_FROM_FZK(&((x)->word)):NJ_GET_BPOS_FROM_STEM(&((x)->word))))

#define RLT_GETSCORE(x) \
    ((s32)((s32)NJ_GET_FREQ_FROM_STEM(&((x)->word)) + (s32)NJC_PHRASE_COST))

#define GIJI_GETSCORE(_len) \
    ((s16)((s16)(_len) * ((NJC_PHRASE_COST * (s16)sizeof(wchar_t)) / 2)))

#define RLT_GETREPRLEN(x) \
    (NJ_GET_KLEN_FROM_STEM(&((x)->word)) + NJ_GET_KLEN_FROM_FZK(&((x)->word)))

#define RLT_GETFZKYOMILEN(x) (NJ_GET_YLEN_FROM_FZK(&((x)->word)))

#define WSENT_GETLASTPOS(x) \
    ((u16)(((x)->phrNum==0)?0:RLT_GETLASTPOS(&((x)->phrases[(x)->phrNum-1]))))

#define FZK_GET_YLEN(x) ((u16)((x)->info1 & 0x7f))
#define FZK_GET_FPOS(x) ((u16)((x)->info1 >> 7))
#define FZK_GET_TLEN(x) ((u16)((x)->info2 & 0x7f))
#define FZK_GET_BPOS(x) ((u16)((x)->info2 >> 7))
#define FZK_GET_FREQ(x) ((s16)((x)->hindo))

#define FZK_SET_FPOS(s,v) ((s)->info1 = ((s)->info1 & 0x007F) | ((v) << 7))
#define FZK_SET_YLEN(s,v) ((s)->info1 = ((s)->info1 & 0xFF80) | ((v) & 0x7F))
#define FZK_SET_BPOS(s,v) ((s)->info2 = ((s)->info2 & 0x007F) | ((v) << 7))
#define FZK_SET_TLEN(s,v) ((s)->info2 = ((s)->info2 & 0xFF80) | ((v) & 0x7F))
#define FZK_SET_FREQ(s,v) ((s)->hindo = (NJ_HINDO)(v))
#define FZK_GET_SCORE(x) \
    ((s32)((s32)FZK_GET_FREQ(x) + (s32)NJC_PHRASE_COST))

#define CNV_GET_OVERRUN(x)  ((u16)((x)->flags & 0x0001))
#define CNV_SET_OVERRUN(s,v) ((s)->flags = (v))


#define CONNECT_R(cf, posF)                                             \
    ((*((cf) + (((posF) - 1) / 8)) & (0x80 >> (((posF) - 1) % 8))) ? 1 : 0)

/************************************************/
/*          iWinn internal common function definitions              */
/************************************************/

/*-----------------------------------------------------*/
/* ncconv.c                                            */
/*-----------------------------------------------------*/
extern s16 njc_conv(NJ_CLASS *iwnn, NJ_DIC_SET *dic, wchar_t *yomi,
                         u8 analyze_level, u8 devide_pos,
                         NJ_RESULT *results, u8 nogiji);
extern s16 njc_zenkouho(NJ_CLASS *iwnn, NJ_RESULT *target,
                             u16 candidate_no, NJ_RESULT *result,
                             u8 top_set);
extern s16 njc_zenkouho1(NJ_CLASS *iwnn, NJ_DIC_SET *dic, NJ_RESULT *target,
                             NJ_RESULT *result);
extern s16 njc_top_conv(NJ_CLASS *iwnn, NJ_DIC_SET *dic, wchar_t *yomi,
                             NJ_RESULT *results, u16 size);
extern u8 njc_init_conv(NJ_CLASS *iwnn);
extern s16 njc_get_stroke(NJ_RESULT *result, wchar_t *stroke,
                               u16 size);
extern s16 njc_get_candidate(NJ_CLASS *iwnn, NJ_RESULT *result, wchar_t *candidate,
                             u16 size);

/*-----------------------------------------------------*/
/* ndapi.c                                             */
/*-----------------------------------------------------*/
extern s16 njd_get_word_data(NJ_CLASS *iwnn, NJ_DIC_SET *dicset, NJ_SEARCH_LOCATION_SET *loctset, u16 dic_idx, NJ_WORD *word);
extern s16 njd_search_word(NJ_CLASS *iwnn, NJ_CURSOR *cursor, u8 comp_flg, u8 *exit_flag);
extern s16 njd_get_word(NJ_CLASS *iwnn, NJ_CURSOR *cursor, NJ_RESULT *result, u8 comp_flg);
extern s16 njd_get_relational_word(NJ_CLASS *iwnn, NJ_RESULT *current, NJ_RESULT *next,
                               NJ_DIC_FREQ *dic_freq);
extern s16 njd_get_stroke(NJ_CLASS *iwnn, NJ_RESULT *result,
                               wchar_t *stroke, u16 size);
extern s16 njd_get_candidate(NJ_CLASS *iwnn, NJ_RESULT *result,
                               wchar_t *candidate, u16 size);
extern s16 njd_get_word_info(NJ_CLASS *iwnn, NJ_RESULT *result, NJ_WORD_INFO *info);
extern s16 njd_add_word(NJ_CLASS *iwnn, NJ_LEARN_WORD_INFO *lword,
                             u8 connect, u8 undo);
extern s16 njd_learn_word(NJ_CLASS *iwnn, NJ_RESULT *l_result, NJ_LEARN_WORD_INFO *lword,
                               u8 connect, u8 undo_flag, u8 ext_hindo_flag);
extern s16 njd_optimize_ext_area(NJ_CLASS *iwnn);
extern s16 njd_init_program_dic_message(NJ_PROGRAM_DIC_MESSAGE* prog_msg);
extern s16 njd_init_search_location_set(NJ_SEARCH_LOCATION_SET* loctset);
extern s16 njd_init_search_condition(NJ_SEARCH_CONDITION* condition);
extern s16 njd_init_word(NJ_WORD* word);
extern s16 njd_set_cursor_search_end(NJ_CURSOR *cursor, u16 dic_id);
extern s16 njd_clear_dicinfo(NJ_DIC_INFO *info);
extern s16 njd_copy_dicinfo(NJ_DIC_INFO *dest_info, NJ_DIC_INFO *src_info, s16 src_mode_type);
extern s32 njd_get_additional_info(NJ_CLASS *iwnn, NJ_RESULT *result, s8 index,
                                        wchar_t *add_info, u32 size);


/*-----------------------------------------------------*/
/* ndbdic.c                                            */
/*-----------------------------------------------------*/
extern s16 njd_b_search_word(NJ_SEARCH_CONDITION *con,
                                  NJ_SEARCH_LOCATION_SET *loctset);
extern s16 njd_b_get_word(NJ_SEARCH_LOCATION_SET *loctset, NJ_WORD *word);
extern s16 njd_b_get_candidate(NJ_WORD *word, wchar_t *candidate,
                                    u16 size);
extern s16 njd_b_get_stroke(NJ_WORD *word, wchar_t *stroke, u16 size);

/*-----------------------------------------------------*/
/* ndfdic.c                                            */
/*-----------------------------------------------------*/
extern s16 njd_f_search_word(NJ_SEARCH_CONDITION *con,
                                  NJ_SEARCH_LOCATION_SET *loctset);
extern s16 njd_f_get_word(NJ_SEARCH_LOCATION_SET *loctset, NJ_WORD *word);
extern s16 njd_f_get_stroke(NJ_WORD *word, wchar_t *stroke,
                                 u16 size);
extern s16 njd_f_get_candidate(NJ_WORD *word, wchar_t *candidate,
                                    u16 size);

/*-----------------------------------------------------*/
/* ndpdic.c                                            */
/*-----------------------------------------------------*/
extern s16 njd_p_search_word(NJ_CLASS * iwnn, NJ_SEARCH_CONDITION *con,
                                  NJ_SEARCH_LOCATION_SET *loctset, u16 dic_idx);
extern s16 njd_p_get_word(NJ_SEARCH_LOCATION_SET *loctset, NJ_WORD *word);
extern s16 njd_p_get_stroke(NJ_WORD *word, wchar_t *stroke,
                                 u16 size);
extern s16 njd_p_get_candidate(NJ_WORD *word, wchar_t *candidate,
                                    u16 size);
extern s16 njd_p_check_additional_info(NJ_CLASS *iwnn, NJ_DIC_HANDLE handle, void *add_info, u32 size);
extern s32 njd_p_get_additional_info(NJ_CLASS *iwnn, NJ_WORD *word, u8 index, wchar_t *add_info, u32 size);

/*-----------------------------------------------------*/
/* ndldic.c                                            */
/*-----------------------------------------------------*/
extern s16 njd_l_search_word(NJ_CLASS *iwnn, NJ_SEARCH_CONDITION *con,
                                  NJ_SEARCH_LOCATION_SET *loctset, u8 comp_flg);
extern s16 njd_l_add_word(NJ_CLASS *iwnn, NJ_LEARN_WORD_INFO *word,
                                u8 connect, u8 type,
                                u8 undo, u8 dictype);

extern s16 njd_l_delete_word(NJ_CLASS *iwnn, NJ_SEARCH_LOCATION *loc);
extern s16 njd_l_get_word(NJ_CLASS *iwnn, NJ_SEARCH_LOCATION_SET *loctset, NJ_WORD *word);
extern s16 njd_l_get_stroke(NJ_CLASS *iwnn, NJ_WORD *word,
                                 wchar_t *stroke, u16 size);
extern s16 njd_l_get_candidate(NJ_CLASS *iwnn, NJ_WORD *word,
                                 wchar_t *candidate, u16 size);
extern s16 njd_l_undo_learn(NJ_CLASS *iwnn, u16 undo_count);
extern s16 njd_l_check_dic(NJ_CLASS *iwnn, NJ_DIC_HANDLE handle, u8 restore);
extern s16 njd_l_init_area(NJ_DIC_HANDLE handle);
extern s16 njd_l_make_space(NJ_CLASS *iwnn, u16 count, u8 mode);
extern s16 njd_l_get_relational_word(NJ_CLASS *iwnn, NJ_SEARCH_LOCATION *loc,
                                 NJ_WORD *word, NJ_DIC_FREQ *mdic_freq);
extern s16 njd_l_check_word_connect(NJ_CLASS *iwnn, NJ_WORD *word);
extern s16 njd_l_get_ext_word_data(NJ_CLASS *iwnn, NJ_WORD *word, u16 *hinsi, u8 *len);
extern s16 njd_l_mld_op_commit(NJ_CLASS *iwnn, NJ_DIC_HANDLE handle);
extern s16 njd_l_mld_op_commit_to_top(NJ_CLASS *iwnn, NJ_DIC_HANDLE handle);
extern s16 njd_l_mld_op_commit_cancel(NJ_CLASS *iwnn, NJ_DIC_HANDLE handle);
extern s16 njd_l_mld_op_get_space(NJ_CLASS *iwnn, NJ_DIC_HANDLE handle);
extern s32 njd_l_get_additional_info(NJ_CLASS *iwnn, NJ_WORD *word, u8 index, wchar_t *add_info, u32 size);

/*-----------------------------------------------------*/
/* ndtdic.c                                            */
/*-----------------------------------------------------*/
extern s16 njd_t_search_word(NJ_CLASS *iwnn, NJ_SEARCH_CONDITION *con,
                                  NJ_SEARCH_LOCATION_SET *loctset, u8 comp_flg, u16 dic_idx);
extern s16 njd_t_get_word(NJ_SEARCH_LOCATION_SET *loctset, NJ_WORD *word);
extern s16 njd_t_get_candidate(NJ_WORD *word, wchar_t *candidate, u16 size);
extern s16 njd_t_get_stroke(NJ_WORD *word, wchar_t *stroke, u16 size);
extern s16 njd_t_get_relational_word(NJ_SEARCH_LOCATION *loc,
                                          NJ_WORD *word, NJ_DIC_FREQ *mdic_freq );
extern s16 njd_t_get_ext_area_size(NJ_CLASS *iwnn, NJ_DIC_HANDLE handle, u32 *size);
extern s16 njd_t_init_ext_area(NJ_CLASS *iwnn, NJ_DIC_HANDLE handle, void *ext_data, u32 size);
extern s16 njd_t_check_ext_area(NJ_CLASS *iwnn, NJ_DIC_HANDLE handle, void *ext_data, u32 size);
extern s16 njd_t_delete_word(NJ_CLASS *iwnn, NJ_SEARCH_LOCATION *loc);
extern s16 njd_t_learn_word(NJ_CLASS *iwnn, NJ_WORD *word, NJ_LEARN_WORD_INFO *lword, u16 idx);
extern s16 njd_t_optimize_ext_area(NJ_CLASS *iwnn, NJ_DIC_HANDLE handle, void *ext_data);
extern u8 njd_t_calc_ext_hindo(NJ_CLASS *iwnn, u8 now);
extern s16 njd_t_check_additional_info(NJ_CLASS *iwnn, NJ_DIC_HANDLE handle, void *add_info, u32 size);
extern s32 njd_t_get_additional_info(NJ_CLASS *iwnn, NJ_WORD *word, u8 index, wchar_t *add_info, u32 size);
extern s32 njd_t_get_flash_dic_cache_size(NJ_CLASS *iwnn, u32 dictype, NJ_FILE* filestream);
extern s32 njd_t_set_flash_dic_info(NJ_CLASS *iwnn, NJ_FLASH_DIC_INFO *fdicinfo, u32 dictype, NJ_FILE* filestream, u8 *cache_area, u32 cache_size);

/*-----------------------------------------------------*/
/* ndrdic.c                                            */
/*-----------------------------------------------------*/
extern s16 njd_r_get_hinsi(NJ_DIC_HANDLE rule, u8 type);
extern s16 njd_r_get_connect(NJ_DIC_HANDLE rule,
                                  u16 hinsi, u8 type,
                                  u8 **connect);
extern s16 njd_r_get_count(NJ_DIC_HANDLE rule,
                                u16 *fcount, u16 *rcount);
extern s16 njd_r_check_group(NJ_DIC_HANDLE rule, u16 pos);

/*-----------------------------------------------------*/
/* neapi.c                                             */
/*-----------------------------------------------------*/
extern NJ_LEARN_WORD_INFO *nje_get_previous_selection(NJ_CLASS *iwnn, s32 count);

/*-----------------------------------------------------*/
/* necode.c                                            */
/*-----------------------------------------------------*/
extern u16 nje_check_string(wchar_t *s, u16 max_len);
extern u8 nje_get_top_char_type(wchar_t *s);
extern s16 nje_convert_kata_to_hira(wchar_t *kata, wchar_t *hira, u16 len, u16 max_len, u8 type);
extern s16 nje_convert_hira_to_kata(wchar_t *hira, wchar_t *kata, u16 len);

/*-----------------------------------------------------*/
/* nchomo.c                                            */
/*-----------------------------------------------------*/
extern s16 nje_append_homonym(NJ_CLASS *iwnn, NJ_RESULT *result,
                                   u16 yomiLen, s16 *offset);
extern u8 nje_clear_homonym_buf(NJ_CLASS *iwnn);
extern s16 nje_append_homonym_string(NJ_CLASS *iwnn, wchar_t *str);
extern wchar_t  *nje_get_homonym_string(NJ_CLASS *iwnn, u16 index);


/*-----------------------------------------------------*/
/* nfapi.c                                             */
/*-----------------------------------------------------*/
extern u8 njf_init_analyze(NJ_CLASS *iwnn);
extern u16 njf_get_keep_result(NJ_CLASS *iwnn, u8 type,
                                     NJ_RESULT **result);
extern s16 njf_get_candidate(NJ_CLASS *iwnn, NJ_RESULT *result,
                                  wchar_t *buf, u16 buf_size);
extern s16 njf_get_stroke(NJ_CLASS *iwnn, NJ_RESULT *result,
                               wchar_t *buf, u16 buf_size);

/*-----------------------------------------------------*/
/* nj_str.c                                            */
/*-----------------------------------------------------*/
extern wchar_t  *nj_strcpy(wchar_t *dst, wchar_t *src);
extern wchar_t  *nj_strncpy(wchar_t *dst, wchar_t *src, u16 n);
extern u16 nj_strlen(wchar_t *c);
extern s16  nj_strcmp(wchar_t *s1, wchar_t *s2);
extern s16  nj_strncmp(wchar_t *s1, wchar_t *s2, u16 n);
extern u16 nj_charlen(wchar_t *c);
extern s16  nj_charncmp(wchar_t *s1, wchar_t *s2, u16 n);
extern wchar_t  *nj_charncpy(wchar_t *dst, wchar_t *src, u16 n);
extern u8 *nj_memcpy(u8 *dst, u8 *src, u16 n);
extern s16  nj_memcmp(u8 *s1,  u8 *s2,  u16 n);
extern u16 nj_strlen_limit(wchar_t *c, u16 limit);

/*-----------------------------------------------------*/
/* ndcommon.c                                          */
/*-----------------------------------------------------*/
extern s16 njd_connect_test(NJ_SEARCH_CONDITION *con, u16 hinsiF, u16 hinsiR);
extern s32 njd_get_attr_bias(NJ_CLASS *iwnn, u32 attr_data);

/*-----------------------------------------------------*/
/* nj_fio.c                                            */
extern s32 nj_fread(u8 *buffer, u32 size, NJ_FILE *filestream);
extern s32 nj_fseek(NJ_FILE *filestream, u32 offset, s32 origin);
extern s32 njd_offset_fread(NJ_FLASH_DIC_INFO *fdicinfo, u32 offset, u32 size, u8 *dst);
extern s32 njd_offset_fread_cache(NJ_FLASH_DIC_INFO *fdicinfo, u32 index, u32 offset, u32 size, u8 **dst, u8 type);



#ifdef __cplusplus 
}
#endif
#endif /* _NJ_EXTERN_H_ */
