/*---------------------------------------------------------------------------*
  Project:  iWnn
  File:     njx_state.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
  
 $Revision: $
 *---------------------------------------------------------------------------*/
 
#ifndef _NJX_STATE_H_
#define _NJX_STATE_H_

#ifdef __cplusplus 
extern "C" {
#endif
 

/************************************************/
/*           Data definitions                         */
/************************************************/
/* Value to add to state setting */
#ifndef NJ_ADD_STATE_TYPE2
/* Please see man pages for details */
static const NJ_STATE_CALC_PARAMETER default_state_calc_parameter = {
#ifndef NJ_OPT_STATE_TYPE2
/* Upper limit value for state setting */
    {NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS,
     NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS,
     NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS,
     NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS},
/* Lower limit value for state setting */
    {NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS},
/* The value to add regardless of confirmed words if the state setting is less than zero */
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
/* The value to be restored up to this value if the state setting matching the confirmed word is smaller than this value */
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
/* Value to be added to the state setting depending on attributes */
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}
    },
#else /* !NJ_OPT_STATE_TYPE2 */
/* Upper limit value for state setting */
    {NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS,
     NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS,
     NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS,
     NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS,
     NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS,
     NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS,
     NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS,
     NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS},
/* Lower limit value for state setting */
    {NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS},
/* The value to add regardless of confirmed words if the state setting is less than zero */
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
/* The value to be restored up to this value if the state setting matching the confirmed word is smaller than this value */
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
/* Value to be added to the state setting depending on attributes */
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0},
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
    },
#endif /* !NJ_OPT_STATE_TYPE2 */
/* Maximum dictionary frequency value */
    {NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ,
     NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ,
     NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ,
     NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ,
     NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ},
/* Minimum dictionary frequency value */
    {NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ,
     NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ,
     NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ,
     NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ,
     NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ}
};
#else /* !NJ_ADD_STATE_TYPE2 */
/* Please see man pages for details 
  
  
  */
static const NJ_STATE_CALC_PARAMETER default_state_calc_parameter = {
#ifndef NJ_OPT_STATE_TYPE2
/* Upper limit value for state setting */
    {NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, /*Personal name, noun, start of sentence*/
     30, 30, /*Soft or hard*/
     100, 100, 100, /*Morning, noon, or night*/
     100, 100, 100, 100, /*Spring, summer, fall and winter*/
     30, 30, /*Past, future*/
     30, 30  /*Positive connotation, negative connotation*/
    },
/* Lower limit value for state setting */
    {NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS},
/* The value to add regardless of confirmed words if the state setting is less than zero */
    {0, 0, 0, 10, 10, 0, 0, 0, 0, 0, 0, 0, 10, 10, 10, 10},
/* The value to be restored up to this value if the state setting matching the confirmed word is smaller than this value */
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
/* Value to be added to the state setting depending on attributes */
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Personal name*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Noun*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Start of sentence*/
     {0, 0, 0, 10,-100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Soft*/
     {0, 0, 0,-100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Hard*/
     {0, 0, 0, 0, 0, 20,-10,-10, 0, 0, 0, 0, 0, 0, 0, 0}, /*Morning*/
     {0, 0, 0, 0, 0,-10, 20,-10, 0, 0, 0, 0, 0, 0, 0, 0}, /*Noon*/
     {0, 0, 0, 0, 0,-10,-10, 20, 0, 0, 0, 0, 0, 0, 0, 0}, /*Night*/
     {0, 0, 0, 0, 0, 0, 0, 0, 10, 0,-10, 0, 0, 0, 0, 0}, /*Spring*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 0,-10, 0, 0, 0, 0}, /*Summer*/
     {0, 0, 0, 0, 0, 0, 0, 0,-10, 0, 10, 0, 0, 0, 0, 0}, /*Autumn*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0,-10, 0, 10, 0, 0, 0, 0}, /*Winter*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,-800, 0, 0}, /*Past*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,-800, 0, 0, 0}, /*Future*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10,-100}, /*Positive*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,-100, 10} /*Negative*/
    },
#else /* !NJ_OPT_STATE_TYPE2 */
/* Upper limit value for state setting */
    {NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, NJ_STATE_MAX_BIAS, /*Personal name, noun, start of sentence*/
     30, 30, /*Soft or hard*/
     100, 100, 100, /*Morning, noon, or night*/
     30, 30, /*Past, future*/
     30, 30,  /*Positive connotation, negative connotation*/
     100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, /* January, February, March, April, May, June, July, August, September, October, November, December */
     0, 0, 0, 0, 0, 0, 0, 0 /* Extra */
    },
/* Lower limit value for state setting */
    {NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS,
     NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS, NJ_STATE_MIN_BIAS},
/* The value to add regardless of confirmed words if the state setting is less than zero */
    {0, 0, 0, 10, 10, 0, 0, 0, 10, 10, 10, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
/* The value to be restored up to this value if the state setting matching the confirmed word is smaller than this value */
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
/* Value to be added to the state setting depending on attributes */
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Personal name*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Noun*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Start of sentence*/
     {0, 0, 0, 10,-100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Soft*/
     {0, 0, 0,-100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Hard*/
     {0, 0, 0, 0, 0, 20,-10,-10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Morning*/
     {0, 0, 0, 0, 0,-10, 20,-10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Noon*/
     {0, 0, 0, 0, 0,-10,-10, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Night*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, -800, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Past*/
     {0, 0, 0, 0, 0, 0, 0, 0, -800, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Future*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, -100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Positive*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Negative*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*January*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*February*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*March*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*April*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*May*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*June*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*July*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*August*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*September*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*October*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*November*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 0, 0, 0, 0, 0, 0, 0, 0}, /*December*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Extra*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Extra*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Extra*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Extra*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Extra*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Extra*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Extra*/
     {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, /*Extra*/
    },
#endif /* !NJ_OPT_STATE_TYPE2 */
/* Maximum dictionary frequency value */
    {NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ,
     NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ,
     NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ,
     NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ,
     NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ, NJ_STATE_MAX_FREQ},
/* Minimum dictionary frequency value */
    {NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ,
     NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ,
     NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ,
     NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ,
     NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ, NJ_STATE_MIN_FREQ}
};
#endif /* !NJ_ADD_STATE_TYPE2 */


#ifdef __cplusplus 
}
#endif
#endif /* _NJX_STATE_H_ */
