/*-----------------------------------------------------------------------*
 Project: iWnn API Demo: File Logging
 File:    fprintf.cpp

 Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law. They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
 *-----------------------------------------------------------------------*/
#include <cstdio>
#include <cstdarg>
#include <string>
#include "fprintf.h"

wchar_t strBuf[FPRINTF_BUF_MAX_SIZE];
extern u16    wcharStringLen(wchar_t *c);  //Function for getting the length of the wchar string
static void ReverseEndian(u16* dest,u16* src,u32 size); //Endian conversion function
/*
 
              
              
              
              

 
 
 

 
 */
void Fprintf(nn::fs::FileOutputStream *file, const wchar_t *format, ...){
    
    va_list list;
    
    
    va_start( list, format );
    vswprintf(strBuf,(size_t)FPRINTF_BUF_MAX_SIZE,format,list);
    
    file->Write(strBuf, (size_t)(wcharStringLen(strBuf)*sizeof(wchar_t)), true);
    va_end( list );

    
    return;
}
/*
 

 
 
 
 

 
 */
void FprintUTF16BE(nn::fs::FileOutputStream *file,wchar_t *buf){
    u32 strLen;
    u32 i;

    strLen = wcharStringLen(buf);
    ReverseEndian((u16*)strBuf,(u16*)buf,strLen); //UTF-16BE --> UTF-16LE
    for(i = 0 ;i < strLen;i++){
        file->Write((u8*)(&strBuf[i]),2,true);
    }
    return;
}
/*
  

  
  
  

  
 */
static void ReverseEndian(u16* dst,u16* src,u32 size){
    u32 i;
    u8 byteLow,byteHigh;
    for(i=0;i<size;i++){
        byteLow= (u8)((src[i] & (u16)0xff00) >> 8);
        byteHigh= (u8)(src[i] & (u16)0x00ff);
        *dst  = (u16)(byteHigh << 8) & (u16)0xff00;
        *dst++ |= (u16)byteLow;
    }
    *dst = (u16)0x00;
}



